VERSION 2.00
Begin Form HelpForm 
   AutoRedraw      =   -1  'True
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Help Window"
   ClientHeight    =   4875
   ClientLeft      =   1185
   ClientTop       =   1890
   ClientWidth     =   6375
   FontTransparent =   0   'False
   Height          =   5565
   Icon            =   QSHELP.FRX:0000
   KeyPreview      =   -1  'True
   Left            =   1125
   LinkTopic       =   "Form2"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   4875
   ScaleWidth      =   6375
   Top             =   1260
   Visible         =   0   'False
   Width           =   6495
   WindowState     =   2  'Maximized
   Begin TextBox tbHelp 
      FontBold        =   0   'False
      FontItalic      =   0   'False
      FontName        =   "MS Sans Serif"
      FontSize        =   9.75
      FontStrikethru  =   0   'False
      FontUnderline   =   0   'False
      Height          =   1215
      Left            =   240
      MultiLine       =   -1  'True
      ScrollBars      =   2  'Vertical
      TabIndex        =   0
      Top             =   240
      Visible         =   0   'False
      Width           =   1455
   End
   Begin Menu mText 
      Caption         =   "&Text"
      Begin Menu mTextCopy 
         Caption         =   "&Copy to Clipboard"
      End
      Begin Menu mTextPrint 
         Caption         =   "&Print"
      End
      Begin Menu mTextExit 
         Caption         =   "E&xit Help"
      End
   End
End
Option Explicit
Dim HelpText$     'Holds text of help box

Sub Form_Activate ()
   
   'Displays context-sensitive help in a text box.
   Dim NL$  'New Line
   NL$ = Chr$(13) + Chr$(10)
   
   'Different text, depending on which pattern is active
   Select Case WhichPattern   'HelpText$ hold the text displayed in the help text box.
      
      Case 0     'Main screen with no pattern showing
	 HelpText$ = "Quick Screen Test is a utility that helps you visually test a computer monitor.  Five patterns help you evaluate six important aspects of a monitor's display. To show one of the patterns, select it from the Pattern Menu. Press 'F1' or '?' at any time for context-sensitive help. To return to the main window, press 'Esc' (or almost any other key), or click the mouse. To end the program, choose Exit from the Pattern Menu." + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "You can change the Focus, Geometry, and Convergence Test patterns by pressing the '+' or '-' keys while the patterns are displayed. Pressing '+' will increase the size of the font in the Focus Pattern, increase the size of the squares in the Geometry Pattern, increase the time between color changes in the Convergence Test Pattern, and increase the number of grays displayed in the Color Tracking Pattern. Pressing '-' will have the opposite effect." + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "If you change the patterns, your changes will be saved in the 'QSTEST.INI' file, which is created the first time you run the program. If the program can't find this file when you run it, it will create a new QSTEST.INI file using the defaults. See below for more details about this file." + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "Each pattern has its own help topic, which explains how to use the pattern and how to adjust the monitor if it has problems in that area. To view a pattern's help topic, press the 'F1' or '?' key while the pattern is displayed. Pressing the same keys when the main window is displayed brings up this help topic. Choose Exit from the Text menu, or click in the help window outside of the text box to hide the help window and return." + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "If you want to print the current help topic, select Print from the Text menu. You can also copy the text to the clipboard by choosing Copy to Clipboard from the Text menu. You can then paste it into Notepad or your word processor. If you select some text before choosing Print or Copy, only the text you have selected will be printed or copied. Otherwise, the entire topic will be printed or copied." + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "There are five lines in the 'QSTEST.INI' file. Normally you should not need to change these. The first line is the font used in the Focus Font pattern. The second line is the size of the font used, in points. The third line holds the Convergence Test pattern time interval, in milliseconds. The fourth line holds the number of gray bars in the Color Tracking pattern. The fifth line holds the number of columns in the Geometry pattern. You can adjust any of these (except the focus font name) from within the program by pressing the '+' or '-' keys." + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "If you want to use a different font in the focus pattern, you can replace the first line of this file with the font's name. Be sure to type it exactly as it appears in your word processor's font list. Only screen fonts will work correctly. If this program can't find the font you typed in the list of Windows screen fonts, it will substitute another." + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "Press Esc, or click outside of the text box to return to the main window."
      
      Case FOCUS
	 HelpText$ = "It is important to have a well-focused monitor. A blurry monitor could cause eyestrain or headaches as well as make it more difficult to do your work." + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "Ideally, all of the text in the Focus pattern should be sharp. Are the characters more fuzzy towards the edges of the screen? Is there good contrast between the black and white pixels, or are the edges of the characters gray?" + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "You can increase the size of the font displayed by pressing the '+' or up-arrow key, and you can decrease the font size by pressing the '-' or down-arrow key. The font name and point size will be indicated in a box in the center of the screen. You will be able to read a smaller font more easily on a sharper monitor. One way to compare the sharpness of two monitors is to see at what font size the text becomes difficult to read or noticeably fuzzy.  NOTE: below a certain size, Windows may substitute a default font, such as MS Serif." + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "Very few monitors have focus controls. However, if the convergence is bad, it can make a screen look fuzzy. Try adjusting the monitor with the Convergence pattern. Adjusting the contrast or brightness controls can often improve the focus somewhat. Other than this, there is not much you can do to improve a monitor's focus." + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "Press Esc to return to the Focus pattern."
      
      Case GEOMETRY
	 HelpText$ = "If you need to do any graphics, page layout, or especially CAD work, it will be important for your monitor to have good geometry. There are many ways that a screen's geometry can be distorted, and most monitors have controls for adjusting some of these distortions." + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "The Geometry pattern consists of a grid and five circles. You can increase the size of the grid squares by pressing the '+' or up-arrow key, or you can decrease their size by pressing the '-' or down-arrow key. Use the monitor's horizontal and vertical position controls to center the image, then use the size controls to make the center circle as round as possible (as opposed to oval-shaped). The horizontal and vertical lines should now be evenly spaced. If they aren't, then the monitor has 'linearity' problems. This means that the spacing between pixel rows or columns is not even. The circles in the corners will also be squashed or elongated. If the monitor has a linearity control (most don't), you can make the spacing more equal. If the linearity is good but the circles in the corners are still not perfectly round, then the monitor has one or more of the other geometry problems below." + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "If vertical lines on the sides of the screen bow inward or outward, try adjusting the pincushion control. If both curve towards the right or left, adjust the pin balance control. Unfortunately, monitors don't have user controls for straightening curved horizontal lines." + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "If the top and bottom edges of the pattern are parallel to the monitor's bezel but the sides aren't, then there is a trapezoid or parallelogram distortion. If the two sides tilt in opposite directions, so that the top of the pattern is not the same width as the bottom, try adjusting the trapezoid control. If both sides tilt the same way, try the parallelogram control (sometimes called the orthogonality control)." + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "If the entire image is tilted (rotated) with respect to the bezel, the tilt or rotation control can improve this. You may notice that the tilt of a monitor changes when you change its orientation. This is due to the earth's magnetic field." + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "Some monitors have more geometry controls. These usually deal with more localized distortions, such as curvature only at the top, bottom, or center of vertical lines. Consult the monitor's manual for instructions." + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "Press Esc to return to the Geometry pattern."
      
      Case CONVTEST
	 HelpText$ = "Convergence problems can be a nuisance and can make a monitor appear blurry. If a monitor has poor convergence, you will see colored 'shadows' or 'halos' on the edges of objects on the screen." + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "The Convergence Test pattern has red-green and blue-green line segments that switch colors at a regular interval. You can increase the time interval by pressing the '+' or up-arrow key, or you can decrease it by pressing the '-' or down-arrow key. Press 'V' to display vertical convergence lines or 'H' to display horizontal convergence lines." + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "Look at the places where the red and green or blue and green segments meet. If the lines move when the colors change, this means those two colors don't line up precisely in that area, which means the convergence is off there." + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "If the monitor has convergence controls (sometimes labeled 'HSTAT' and 'VSTAT'), you might be able to improve the convergence. This will be easier to do with the Convergence Adjustment pattern, and you can find instructions in that pattern's help topic." + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "Press Esc to return to the Convergence Test pattern."
      
      Case CONVADJUST
	 HelpText$ = "This is the Convergence Adjustment pattern. Convergence problems will stand out more in the Convergence Test pattern, but this pattern is better for adjusting convergence, since you can easily see the convergence of the entire screen at once." + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "All of the colors displayed on a monitor are made by combining red, green, and blue light in different intensities. White is made by combining these three primary colors at their maximum intensity. Ideally, in the Convergence Adjustment pattern, the red, green, and blue images should line up to form white lines. If they don't line up well, the sides of the lines will have a tinge of color." + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "You might be able to improve a monitor's convergence by adjusting the convergence control. However, this will affect the entire screen, so you will often make one area worse when you try to improve another area. A good starting point is to get the center line adjusted as well as you can. Then see if you can improve the overall convergence by adjusting the controls slightly. Almost all monitors have some misconvergence, so don't expect to make the convergence perfect over the entire screen." + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "Note that the horizontal convergence or HSTAT control will affect the vertical lines, and the vertical convergence or VSTAT control will affect the horizontal lines." + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "Press Esc to return to the Convergence Adjustment pattern."
      
      Case COLORTRACKING
	 HelpText$ = "A color monitor has three electron guns, which individually can only produce red, green, or blue. The monitor combines these primary colors to produce all of its other colors. To produce white, all three primary colors are combined at their maximum intensity. Gray is produced by reducing the intensity of the primary colors, keeping their ratios the same. A monitor that has trouble keeping the ratios consistent is said to have poor color tracking, and it will not display colors accurately." + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "The easiest way to see the color tracking of a monitor is to display different shades of gray on it. You can increase the number of gray bars displayed in the Color Tracking pattern by pressing the '+' or up-arrow key, or decrease the number by pressing the '-' or down-arrow key. If you try to display more grays than the Windows palette can handle, you will get dithered approximations of some of the shades of gray. For this test you should not have any dithered grays. The number of undithered grays that can be displayed depends on your windows video driver and your video card. If you are running Windows with 16 or 256 colors, use only the lowest setting of four bars. If you are in 65,000 color mode, you can display 32 undithered grays. In 24-bit or true color mode (16.7 million colors), you can display up to 256 undithered bars, which is this program's maximum." + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "Ideally, all of the bars in the Color Tracking pattern should have no coloration. If the bars towards one side are tinted (for example, the darker grays might look reddish), the monitor's color tracking is off. Unfortunately, there is no way to adjust color tracking, without special equipment that only comes with a few of the high-end monitors." + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "NOTE: Dithering is more obvious at low resolutions. At high resolutions the dithering may look more like discoloration. If alternate grays get lighter and darker, instead of a smooth progression of intensity from the left to the right, that is probably because some of the bars are dithered. In this case, press '-' until none of the grays are dithered." + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "Press Esc to return to the Color Tracking pattern."
      
      Case PURITY
	 HelpText$ = "The best way to test both purity and flicker is to look at a pure white screen, with no patterns to obscure it. A monitor with good purity and uniformity will show a uniform shade of white. The tint and brightness of the white should not vary from location to location." + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "Look for discolorations (lack of purity), which indicate that the electron guns are misaligned or that the monitor has been affected by a strong magnetic field. You can sometimes improve the purity and uniformity of a monitor by pressing the degauss button. If your monitor doesn't have a degauss button, try turning it off and back on. Many monitors automatically degauss themselves when they are turned on." + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "IMPORTANT: Degaussing your monitor more than once will not help any more than degaussing it once. If you don't wait for several minutes between degaussings, you could damage the degauss mechanism on some monitors." + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "Flicker will be more noticeable if you direct your eyes above, below, or to the side of the monitor. Flicker can usually be reduced by increasing the vertical refresh rate that your video card outputs. See your video card manual for details." + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "IMPORTANT: Before you increase the refresh rate, make sure the monitor can handle a higher rate at the current resolution. If you are not sure, don't change it, because you could damage the monitor. If the picture scrolls, looks wavy, or goes blank, this means the monitor can't handle the refresh rate the card is supplying, and you should change back to a lower refresh rate." + NL$
	 HelpText$ = HelpText$ + "" + NL$
	 HelpText$ = HelpText$ + "Press Esc to return to the Purity pattern."
   End Select

   ' The following code positions, sizes, and displays
   ' HelpText$ in a text box control.
   tbHelp.Width = HelpForm.ScaleWidth / 2
   tbHelp.Left = HelpForm.ScaleWidth / 4
   tbHelp.Text = HelpText$
   tbHelp.Height = HelpForm.ScaleHeight / 1.5
   tbHelp.Top = HelpForm.Top + HelpForm.ScaleHeight / 8
   tbHelp.Visible = True

End Sub

Sub Form_Click ()
   'Hides the help window
   HelpText$ = ""
   tbHelp.Text = ""
   Hide
End Sub

Sub Form_DblClick ()
   'Behave like mouse click: hide help window
   Form_Click
End Sub

Sub Form_KeyPress (KeyAscii As Integer)
   'Behave like mouse click: hide help window
   Form_Click
End Sub

Sub Form_Load ()
   tbHelp.FontName = FocusFont$
   tbHelp.FontSize = 12
   tbHelp.FontBold = True
End Sub

Sub mTextCopy_Click ()
   
   'This routine copies text to the clipboard.
   If tbHelp.SelLength > 0 Then  'text selected, so copy it
      Clipboard.SetText tbHelp.SelText
   Else     'no text is selected, so copy entire topic
      Clipboard.SetText HelpText$
   End If

End Sub

Sub mTextExit_Click ()
   'Same as clicking on help form - hides the form.
   Form_Click
End Sub

Sub mTextPrint_Click ()
   
   'This Sub prints the help text.
   Dim Pos, ToPrint$, P$, NL$
   NL$ = Chr$(13) + Chr$(10)
   On Error GoTo PrintErrorHandler
   
   If tbHelp.SelLength > 0 Then  'text is selected, so
      ToPrint$ = tbHelp.SelText     'print selected text
   Else                          'no text is selected, so
      ToPrint$ = HelpText$          'print entire topic
   End If
      
   'The following loop formats text to 80 character lines.
   While Len(ToPrint$) > 80
      P$ = Left$(ToPrint$, 80)
      'Search for carriage returns.
      Pos = InStr(P$, NL$)
      If Pos Then
	 P$ = Left$(P$, Pos)
	 ToPrint$ = Right$(ToPrint$, Len(ToPrint$) - Len(P$) - 2)
      Else
	 'The following loop removes partial words from
	 'end of line.
	 While Right$(P$, 1) <> " "
	    P$ = Left$(P$, Len(P$) - 1)
	 Wend
      ToPrint$ = Right$(ToPrint$, Len(ToPrint$) - Len(P$))
      End If
      Printer.Print P$        'Print a line
      'The following loop removes leading spaces
      While Left$(ToPrint$, 1) = " "
	 ToPrint$ = Right$(ToPrint$, Len(ToPrint$) - 1)
      Wend
   Wend
   
   Printer.Print ToPrint$    'Print final line
   Printer.NewPage              'Form feed
   Printer.EndDoc               'Release printer

Exit Sub

PrintErrorHandler:
   MsgBox "There was a problem printing to your printer."
   Exit Sub
End Sub

