VERSION 2.00
Begin Form MainForm 
   Caption         =   "Quick Screen Test"
   ClientHeight    =   4140
   ClientLeft      =   870
   ClientTop       =   1650
   ClientWidth     =   7305
   Height          =   4830
   KeyPreview      =   -1  'True
   Left            =   810
   LinkTopic       =   "Form1"
   ScaleHeight     =   4140
   ScaleWidth      =   7305
   Top             =   1020
   Width           =   7425
   WindowState     =   2  'Maximized
   Begin Menu mPattern 
      Caption         =   "&Pattern"
      Begin Menu mPatternFocus 
         Caption         =   "&Focus"
      End
      Begin Menu mPatternGeometry 
         Caption         =   "&Geometry"
      End
      Begin Menu mPatternConvergence 
         Caption         =   "&Convergence"
         Begin Menu mPatternConvergenceTest 
            Caption         =   "Convergence &Test"
         End
         Begin Menu mPatternConvergenceAdjust 
            Caption         =   "Convergence &Adjust"
         End
      End
      Begin Menu mPatternColorTracking 
         Caption         =   "Color &Tracking"
      End
      Begin Menu mPatternPurity 
         Caption         =   "&Purity/Flicker"
      End
      Begin Menu mPatternDivider1 
         Caption         =   "-"
      End
      Begin Menu mFileExit 
         Caption         =   "E&xit"
      End
   End
   Begin Menu mHelp 
      Caption         =   "&Help"
      Begin Menu mHelpSummary 
         Caption         =   "&Help Summary"
      End
      Begin Menu mHelpAbout 
         Caption         =   "&About"
      End
   End
End
Option Explicit
DefInt A-Z

Sub Form_Activate ()
   WhichPattern = 0  'no pattern selected when
                     'main form is showing
End Sub

Sub Form_KeyDown (KeyCode As Integer, Shift As Integer)
   Select Case KeyCode
      Case KEY_F1    'F1 brings up help screen
         HelpForm.Show
   End Select
End Sub

Sub Form_KeyPress (KeyAscii As Integer)
   Select Case KeyAscii
      Case 47, 63    ' / or ? brings up help screen
         HelpForm.Show
   End Select
End Sub

Sub Form_Load ()
   
   'Initializations:
   Dim S$   'file input holder
   WhichPattern = 0
   
   'Get previous settings from .INI file
   On Error GoTo ErrorHandler 'in case no .INI file
   Open "QSTEST.INI" For Input As #1
   Input #1, FocusFont$
   Input #1, S$
   FocusFontSize = Val(S$)
   If FocusFontSize < 4 Or FocusFontSize > 24 Then FocusFontSize = 8
   Input #1, S$
   TimeInterval = Val(S$)
   If TimeInterval > 2000 Or TimeInterval < 10 Then TimeInterval = 500
   Input #1, S$
   NumberOfGrays = Val(S$)
   If NumberOfGrays < 4 Or NumberOfGrays > 256 Then NumberOfGrays = 4
   Input #1, S$
   NumCols = Val(S$)
   If NumCols < 4 Or NumCols > 80 Then NumCols = 32
   Close #1
   
   'Make sure font is in the system
   CheckFont
   Exit Sub

ErrorHandler:
   'Create QSTEST.INI if it doesn't exist
   Close
   Open "QSTEST.INI" For Output As #1
   Print #1, "HELV"     'FntName$ = PatternForm.FontName
   Print #1, "8"        'FntSize = PatternForm.FontSize
   Print #1, "500"      'TimeInterval = PatternForm.Timer1.Interval
   Print #1, "4"        'NumberOfGrays for ColorTracking
   Print #1, "32"       'NumCols for Geometry pattern
   Close #1
Resume 0    'Go back to get these settings from .INI file

End Sub

Sub mFileExit_Click ()
   
   'Write current settings to .INI file:
   Open "QSTEST.INI" For Output As #1
   Print #1, FocusFont$    ' = PatternForm.FontName
   Print #1, FocusFontSize ' = PatternForm.FontSize
   Print #1, TimeInterval  ' = PatternForm.Timer1.Interval
   Print #1, NumberOfGrays ' for ColorTracking
   Print #1, NumCols       ' for Geometry
   Close #1
   End      'End the program

End Sub

Sub mHelpAbout_Click ()
   
   'Display an About box.
   Dim Msg$
   Msg$ = "Quick Screen Test"
   Msg$ = Msg$ + Chr$(10)
   Msg$ = Msg$ + "Copyright 1995 Ziff Davis"
   Msg$ = Msg$ + Chr$(10)
   Msg$ = Msg$ + "Written by Brian Fikes"
   MsgBox Msg$, 0, "Quick Screen Test"

End Sub

Sub mHelpSummary_Click ()
   
   'Display general help on the program.
   HelpForm.Show

End Sub

Sub mPatternColorTracking_Click ()
   
   WhichPattern = COLORTRACKING
   If WhichPattern <> OldPattern Then
      PatternForm.BackColor = WHITE
      PatternForm.ForeColor = BLACK
      PatternForm.Cls
   End If
   PatternForm.Show

End Sub

Sub mPatternConvergenceAdjust_Click ()
   
   WhichPattern = CONVADJUST
   If WhichPattern <> OldPattern Then
      PatternForm.BackColor = BLACK
      PatternForm.ForeColor = WHITE
      PatternForm.Cls
   End If
   PatternForm.Show

End Sub

Sub mPatternConvergenceTest_Click ()
   
   WhichPattern = CONVTEST
   If WhichPattern <> OldPattern Then
      PatternForm.BackColor = BLACK
      PatternForm.ForeColor = WHITE
      PatternForm.Cls
   End If
   PatternForm.Show

End Sub

Sub mPatternFocus_Click ()
   
   WhichPattern = FOCUS
   If WhichPattern <> OldPattern Then
      PatternForm.BackColor = WHITE
      PatternForm.ForeColor = BLACK
      PatternForm.Cls
   End If
   PatternForm.Show

End Sub

Sub mPatternGeometry_Click ()
   
   WhichPattern = GEOMETRY
   If WhichPattern <> OldPattern Then
      PatternForm.BackColor = BLACK
      PatternForm.ForeColor = WHITE
      PatternForm.Cls
   End If
   PatternForm.Show

End Sub

Sub mPatternPurity_Click ()
   
   WhichPattern = PURITY
   If WhichPattern <> OldPattern Then
      PatternForm.BackColor = WHITE
      PatternForm.ForeColor = BLACK
      PatternForm.Cls
   End If
   PatternForm.Show

End Sub

